package test;

import aterm.pure.PureFactory;

public class PeanoFactory extends PureFactory
{
  private aterm.AFun funNat_Zero;
  private Nat protoNat_Zero;
  private aterm.AFun funNat_Suc;
  private Nat protoNat_Suc;
  private aterm.AFun funStart_Nat;
  private Start protoStart_Nat;
  private aterm.AFun funOptLayout_Absent;
  private OptLayout protoOptLayout_Absent;
  private aterm.AFun funOptLayout_Present;
  private OptLayout protoOptLayout_Present;
  private aterm.AFun funCHARLIST_String;
  private CHARLIST protoCHARLIST_String;

  public PeanoFactory()
  {
     super();
     initialize();
  }

  public PeanoFactory(int logSize)
  {
     super(logSize);
     initialize();
  }

  private void initialize()
  {
    Nat.initialize(this);

    Nat_Zero.initializePattern();
    funNat_Zero = makeAFun("Nat_Zero", 0, false);
    protoNat_Zero = new Nat_Zero();

    Nat_Suc.initializePattern();
    funNat_Suc = makeAFun("Nat_Suc", 4, false);
    protoNat_Suc = new Nat_Suc();

    Start.initialize(this);

    Start_Nat.initializePattern();
    funStart_Nat = makeAFun("Start_Nat", 4, false);
    protoStart_Nat = new Start_Nat();

    OptLayout.initialize(this);

    OptLayout_Absent.initializePattern();
    funOptLayout_Absent = makeAFun("OptLayout_Absent", 0, false);
    protoOptLayout_Absent = new OptLayout_Absent();

    OptLayout_Present.initializePattern();
    funOptLayout_Present = makeAFun("OptLayout_Present", 1, false);
    protoOptLayout_Present = new OptLayout_Present();

    CHARLIST.initialize(this);

    CHARLIST_String.initializePattern();
    funCHARLIST_String = makeAFun("CHARLIST_String", 1, false);
    protoCHARLIST_String = new CHARLIST_String();

  }

  protected Nat makeNat_Zero(aterm.AFun fun, aterm.ATerm[] args, aterm.ATermList annos) {
    synchronized (protoNat_Zero) {
      protoNat_Zero.initHashCode(annos,fun,args);
      return (Nat) build(protoNat_Zero);
    }
  }

  public Nat makeNat_Zero() {
    aterm.ATerm[] args = new aterm.ATerm[] {};
    return makeNat_Zero( funNat_Zero, args, empty);
  }

  protected Nat makeNat_Suc(aterm.AFun fun, aterm.ATerm[] args, aterm.ATermList annos) {
    synchronized (protoNat_Suc) {
      protoNat_Suc.initHashCode(annos,fun,args);
      return (Nat) build(protoNat_Suc);
    }
  }

  public Nat makeNat_Suc(OptLayout _wsAfterSuc, OptLayout _wsAfterParenOpen, Nat _pred, OptLayout _wsAfterPred) {
    aterm.ATerm[] args = new aterm.ATerm[] {_wsAfterSuc, _wsAfterParenOpen, _pred, _wsAfterPred};
    return makeNat_Suc( funNat_Suc, args, empty);
  }

  protected Start makeStart_Nat(aterm.AFun fun, aterm.ATerm[] args, aterm.ATermList annos) {
    synchronized (protoStart_Nat) {
      protoStart_Nat.initHashCode(annos,fun,args);
      return (Start) build(protoStart_Nat);
    }
  }

  public Start makeStart_Nat(OptLayout _wsBefore, Nat _topNat, OptLayout _wsAfter, Integer _ambCnt) {
    aterm.ATerm[] args = new aterm.ATerm[] {_wsBefore, _topNat, _wsAfter, makeInt(_ambCnt.intValue())};
    return makeStart_Nat( funStart_Nat, args, empty);
  }

  protected OptLayout makeOptLayout_Absent(aterm.AFun fun, aterm.ATerm[] args, aterm.ATermList annos) {
    synchronized (protoOptLayout_Absent) {
      protoOptLayout_Absent.initHashCode(annos,fun,args);
      return (OptLayout) build(protoOptLayout_Absent);
    }
  }

  public OptLayout makeOptLayout_Absent() {
    aterm.ATerm[] args = new aterm.ATerm[] {};
    return makeOptLayout_Absent( funOptLayout_Absent, args, empty);
  }

  protected OptLayout makeOptLayout_Present(aterm.AFun fun, aterm.ATerm[] args, aterm.ATermList annos) {
    synchronized (protoOptLayout_Present) {
      protoOptLayout_Present.initHashCode(annos,fun,args);
      return (OptLayout) build(protoOptLayout_Present);
    }
  }

  public OptLayout makeOptLayout_Present(CHARLIST _chars) {
    aterm.ATerm[] args = new aterm.ATerm[] {_chars};
    return makeOptLayout_Present( funOptLayout_Present, args, empty);
  }

  protected CHARLIST makeCHARLIST_String(aterm.AFun fun, aterm.ATerm[] args, aterm.ATermList annos) {
    synchronized (protoCHARLIST_String) {
      protoCHARLIST_String.initHashCode(annos,fun,args);
      return (CHARLIST) build(protoCHARLIST_String);
    }
  }

  public CHARLIST makeCHARLIST_String(String _string) {
    aterm.ATerm[] args = new aterm.ATerm[] {makeAppl(makeAFun(_string, 0, true))};
    return makeCHARLIST_String( funCHARLIST_String, args, empty);
  }

}
