package test;

import java.io.InputStream;
import java.io.IOException;


abstract public class StartImpl extends PeanoConstructor
{
  static Start fromString(String str)
  {
    aterm.ATerm trm = getStaticPeanoFactory().parse(str);
    return fromTerm(trm);
  }

  static Start fromTextFile(InputStream stream) throws aterm.ParseError, IOException
  {
    aterm.ATerm trm = getStaticPeanoFactory().readFromTextFile(stream);
    return fromTerm(trm);
  }

  public boolean isEqual(Start peer)
  {
    return term.isEqual(peer.toTerm());
  }

  public static Start fromTerm(aterm.ATerm trm)
  {
    Start tmp;
    if ((tmp = Start_Nat.fromTerm(trm)) != null) {
      return tmp;
    }


    throw new RuntimeException("This is not a Start: " + trm);
  }


  public boolean isNat()
  {
    return false;
  }

  public boolean hasWsBefore()
  {
    return false;
  }

  public boolean hasTopNat()
  {
    return false;
  }

  public boolean hasWsAfter()
  {
    return false;
  }

  public boolean hasAmbCnt()
  {
    return false;
  }


  public OptLayout getWsBefore()
  {
     throw new RuntimeException("This Start has no WsBefore");
  }

  public Start setWsBefore(OptLayout _wsBefore)
  {
     throw new RuntimeException("This Start has no WsBefore");
  }

  public Nat getTopNat()
  {
     throw new RuntimeException("This Start has no TopNat");
  }

  public Start setTopNat(Nat _topNat)
  {
     throw new RuntimeException("This Start has no TopNat");
  }

  public OptLayout getWsAfter()
  {
     throw new RuntimeException("This Start has no WsAfter");
  }

  public Start setWsAfter(OptLayout _wsAfter)
  {
     throw new RuntimeException("This Start has no WsAfter");
  }

  public Integer getAmbCnt()
  {
     throw new RuntimeException("This Start has no AmbCnt");
  }

  public Start setAmbCnt(Integer _ambCnt)
  {
     throw new RuntimeException("This Start has no AmbCnt");
  }



}

